#include <iostream>
using namespace std;

// Define a Estrutura N
struct No {
    int valor;      // Valor armazenado
    No * prox;      // Ponteiro para prximo elemento da lista
};

// Define a Fila
struct Fila {
    No * ini;       // Incio da fila
    No * fim;       // Fim da fila
};

// Insere valor da lista
int inserir(Fila &f, int valor);
// Remove elemento da lista
int remover(Fila &f, int &valor);

int main(void) {
    // Declara e inicializa fila
    Fila fila;
    fila.ini = fila.fim = NULL;

   // Varivel para armazenar dado digitado
    int dado;
    int n;

    cout << "Quantos valores deseja enfileirar? ";
    cin >> n;

    while (n>0) {
        cout << "Digite um numero inteiro: ";
        cin >> dado;
        inserir(fila, dado);
        n--;
    }

    // Agora mostra o reultado...
    while (remover(fila, dado) == 0) {
        cout << dado << endl;
    };
}

// Insere um valor na fila
int inserir(Fila &f, int valor) {
    No * tmp; // Ponteiro para armazenar endereo de n temporariamente
    // Cria n
    tmp = new No;
    // Configura n...
    tmp->valor = valor; // Valor do n
    tmp->prox = NULL; // Sempre insere no fim da fila
    // Se lista vazia, insere primeiro elemento
    if (f.ini == NULL) {
        f.ini = f.fim = tmp; // O primeiro elemento  o primeiro e o ltimo
    }
    // Se lista no est vazia, atualiza lista...
    else {
        f.fim->prox = tmp; // Pendura novo elemento no antigo fim
        f.fim = tmp; // Indica que novo elemento  o novo fim
    }
    // Retorna que insero ocorreu com sucesso
    return 0;
}


// Remove um valor da fila
int remover(Fila &f, int &valor) {
    No * tmp; // Ponteiro temporrio
    // Se a lista est vazia, vai embora
    if (f.ini == NULL) return 1;
    // Armazena valor do elemento sendo removido
    valor = f.ini->valor;
    // Armazena endereo de elemento a ser removido
    tmp = f.ini;
    // Aponta inicio da lista para segundo elemento (novo primeiro!)
    f.ini = f.ini->prox;
    // Remove o primeiro elemento da lista
    delete tmp;
    // Boa prtica... se a lista ficou vazia, atualiza ltimo ponteiro
    if (f.ini == NULL) f.fim = NULL;
    // Retorna novo incio da lista
    return 0;
}

